
// Declare the service object 
var so;
var gpsZip = 'none';
var haveSo = false;
var gpsTimeout;

function getDeviceSo()
{
	try  {
		so = device.getServiceObject("Service.Location", "ILocation");
		haveSo = true;
		return true;
	} catch (e) {
		return false;	
	}
}

function getLocationFromFront()
{
	vibrate();
	getLocation()
}

// Get Location Async
function getLocation() 
{
	gpsZip = 'none';
	//alert('getting location - zip=' + zip);
	if (!haveSo) {
		getDeviceSo();
	}
	
	var updateoptions = new Object();
	updateoptions.PartialUpdates = false;
	
	var criteria = new Object();
	criteria.LocationInformationClass = "BasicLocationInformation";
	criteria.Updateoptions = updateoptions;
	
	try 
	{
		var result = so.ILocation.GetLocation(criteria, locCallback);
		
		if (!debug)	{
			window.menu.getMenuItemById(2008).setDimmed(false);
			if (enableRSK) {
				//window.menu.setRightSoftkeyLabel(localizedMenu['cancel_gps'], cancelGPS);
			}
		}
		//document.getElementById("citySelect").disabled = true;
		clearWeather();
 		showProgress('gps', document.getElementById("lLocation"));
		gpsTimeout = setTimeout("cancelGPS('to')",60000);
	}
	catch (e) 
	{
		gpsZip = 'none';
		if (zip != '' && zip != null) {
			setLocationList(false);
			setTimeout('loadWeather(zip,units)',100);
		} else {
			document.getElementById("mvLocation").innerHTML = "AccuWeather.com";
			document.getElementById("rIcon_mv").src = "images/wxicons/04.png";
			document.getElementById("mvCurrentText").innerHTML = localizedText['qtn_add_location'];
			if (LAYOUT_RIGHT2LEFT) {
				document.getElementById("mvCurrentText").textAlign = 'right';
			} else {
				document.getElementById("mvCurrentText").textAlign = 'left';
			}
			toggleSettings('a');
			showPrefs();
		}
		//document.getElementById("citySelect").disabled = false;
		alert(localizedText['qtn_gps_error']);
	}
}



// Get Location Async
function getLocationUpdate() 
{
	if (!haveSo) {
		getDeviceSo();
	}
	
	var updateoptions = new Object();
	updateoptions.PartialUpdates = false;
	
	var criteria = new Object();
	criteria.LocationInformationClass = "BasicLocationInformation";
	criteria.Updateoptions = updateoptions;
	
	try 
	{
		var result = so.ILocation.GetLocation(criteria, locUpdateCallback);
		gpsTimeout = setTimeout("cancelGPS('up')",60000);
	}
	catch (e) {	}
}



function cancelGPS(type)
{
	if (loadingInt != null) {	
		clearInterval(loadingInt);
	}
	clearTimeout(gpsTimeout);
	//document.getElementById("citySelect").disabled = false;
	var criteria = new Object();
	criteria.CancelRequestType = 'GetLocCancel';
	
	try {
		var result = so.ILocation.CancelNotification(criteria);	 
	} catch (e) {
		
	}
	
	if (!debug)	{
		window.menu.getMenuItemById(2008).setDimmed(true);
		if (enableRSK) {
			//window.menu.setRightSoftkeyLabel('', null);
		}
	}
	
	if (type == 'to') {
		alert(localizedText['qtn_gps_error']);
	} else if (type == 'up') {
		return;	
	}
	
	gpsZip = 'none';
	if (zip != '' && zip != null) {	
		setLocationList(false);
		setTimeout('loadWeather(zip,units)',100);
	} else {
		document.getElementById("mvLocation").innerHTML = "AccuWeather.com";
		document.getElementById("rIcon_mv").src = "images/wxicons/04.png";
		document.getElementById("mvCurrentText").innerHTML = localizedText['qtn_add_location'];
		if (LAYOUT_RIGHT2LEFT) {
			document.getElementById("mvCurrentText").textAlign = 'right';
		} else {
			document.getElementById("mvCurrentText").textAlign = 'left';
		}
		toggleSettings('a');
		showPrefs();
	}
}


function locCallback(transId, eventCode, result)
{
	clearTimeout(gpsTimeout);
	vibrate();
	//document.getElementById("citySelect").disabled = false;
	
	if (!debug) {	
		window.menu.getMenuItemById(2008).setDimmed(true);
	}
	
	if(result.ErrorCode)
	{
		alert (localizedText['qtn_gps_error']);
		
		gpsZip = 'none';
		if (zip != '' && zip != null) {	
			setLocationList(false);
			setTimeout('loadWeather(zip,units)',100);
		} else {
			document.getElementById("mvLocation").innerHTML = "AccuWeather.com";
			document.getElementById("rIcon_mv").src = "images/wxicons/04.png";
			document.getElementById("mvCurrentText").innerHTML = localizedText['qtn_add_location'];
			if (LAYOUT_RIGHT2LEFT) {
				document.getElementById("mvCurrentText").textAlign = 'right';
			} else {
				document.getElementById("mvCurrentText").textAlign = 'left';
			}
			toggleSettings('a');
			showPrefs();
		}
	}
	else
	{
		var lat = result.ReturnValue.Latitude.toString();
		var lon = result.ReturnValue.Longitude.toString();
		
		gpsZip = lat.substr(0,6)+'~'+lon.substr(0,6);
		setLocationList(true);
		loadWeather(gpsZip,units);
	}
}


function locUpdateCallback(transId, eventCode, result)
{
	clearTimeout(gpsTimeout);
	if(result.ErrorCode) {
		alert (localizedText['qtn_gps_error']);
	} else {
		var lat = result.ReturnValue.Latitude.toString();
		var lon = result.ReturnValue.Longitude.toString();
		
		gpsZip = lat.substr(0,6)+'~'+lon.substr(0,6);
		setLocationList(true);
		loadData(gpsZip,units);
	}
}

