//original accuweather.js file
var zip = '';
var zipDef = '';
var zipRecent = '';
var xmlData;
var units="metric";
var datefmt="dd";
var wxview="forecast";
var setview = "a";
var zipAr = [];
var locAr = [];
var zipStr = '';
var locStr = '';
var zLevel = 3;
var hLevel = 1;
var fLevel = 1;
var version = '1.0.20090513';
var ckeVersion;
var loadingInt;
var updateInt = null;
var loadingCtr = 0
var screenMode = -1;
var sysinfo;
var updateWait = 15;	//number of minutes
var startCalled = false;

var adcUrl = "http://nokia.accu-weather.com/widget/nokias60/";
 
var debug = false;

var enableRSK = true;

//preload images
var imgSpace = new Image(10,8);
imgSpace.src = 'images/space.png';
var imgPageIconOn = new Image(16,16); 
imgPageIconOn.src="images/pageicon_on.png"; 
var imgPageIconOff = new Image(16,16); 
imgPageIconOff.src="images/pageicon_off.png";
var imgPageArwLft = new Image(90,16); 
imgPageArwLft.src="images/arrow_left.png"; 
var imgPageArwRgt = new Image(90,16); 
imgPageArwRgt.src="images/arrow_right.png"; 
var imgPageZoomOut = new Image(90,16); 
imgPageZoomOut.src="images/icon_zoomout.png"; 
var imgPageZoomIn = new Image(90,16); 
imgPageZoomIn.src="images/icon_zoomin.png"; 

//pre-load nav images
var imgNavForecastOn = new Image(54,100);
var imgNavForecastOff = new Image(54,100);
imgNavForecastOn.src = "images/nav_forecast_on.png";
imgNavForecastOff.src = "images/nav_forecast_off.png";
var imgNavHourlyOn = new Image(55,100);
var imgNavHourlyOff = new Image(55,100);
imgNavHourlyOn.src = "images/nav_hourly_on.png";
imgNavHourlyOff.src = "images/nav_hourly_off.png";
var imgNavMapsOn = new Image(49,100);
var imgNavMapsOff = new Image(49,100);
imgNavMapsOn.src = "images/nav_maps_on.png";
imgNavMapsOff.src = "images/nav_maps_off.png";
var imgNavGraphOn = new Image(53,100);
var imgNavGraphOff = new Image(53,100);
imgNavGraphOn.src = "images/nav_graph_on.png";
imgNavGraphOff.src = "images/nav_graph_off.png";
var imgNavCalendarOn = new Image(56,100);
var imgNavCalendarOff = new Image(56,100);
imgNavCalendarOn.src = "images/nav_calendar_on.png";
imgNavCalendarOff.src = "images/nav_calendar_off.png";

//settings nav
var imgNavAddOn = new Image(80,100);
var imgNavAddOff = new Image(80,100);
imgNavAddOn.src = "images/nav_add_on.png";
imgNavAddOff.src = "images/nav_add_off.png";
var imgNavManageOn = new Image(80,100);
var imgNavManageOff = new Image(80,100);
imgNavManageOn.src = "images/nav_manage_on.png";
imgNavManageOff.src = "images/nav_manage_off.png";
var imgNavSettingsOn = new Image(80,100);
var imgNavSettingsOff = new Image(80,100);
imgNavSettingsOn.src = "images/nav_settings_on.png";
imgNavSettingsOff.src = "images/nav_settings_off.png";

if (debug) {
	window.widget = true;
	adcUrl = "http://devoweb.accuweather.com/widget/nokias60/";
}
	
function showProgress(type, obj)
{
	obj.innerHTML = '';
	if (loadingInt != null)	{
		clearInterval(loadingInt);
	}
	loadingCtr = 0;
	var str = localizedText['qtn_loading'];
	switch (type)
	{
		case 'gps':
			str = localizedText['qtn_get_position'];
			break;
		case 'load':
			str = localizedText['qtn_loading'];
			break;
		case 'search':
			str = localizedText['qtn_searching'];
			break;
	}
	
	if (LAYOUT_RIGHT2LEFT) {
		obj.style.textAlign = 'right';	
	} else {
		obj.style.textAlign = 'left';
	}
	
	loadingInt = setInterval(updateProgress,300,str,obj);
}

function translate(str)
{
	var new_str = str;
	switch (str)
	{
		case 'Sunday': new_str = localizedText['qtn_sunday']; break;
		case 'Monday': new_str = localizedText['qtn_monday']; break;
		case 'Tuesday': new_str = localizedText['qtn_tuesday']; break;
		case 'Wednesday': new_str = localizedText['qtn_wednesday']; break;
		case 'Thursday': new_str = localizedText['qtn_thursday']; break;
		case 'Friday': new_str = localizedText['qtn_friday']; break;
		case 'Saturday': new_str = localizedText['qtn_saturday']; break;
	}
	return new_str;
}

function updateProgress(str,obj)
{
	var nstr = str;
	loadingCtr++;
	if (loadingCtr > 3) {
		loadingCtr = 0;
	}
	
	if (LAYOUT_RIGHT2LEFT) {
		for (var i=0;i<loadingCtr;i++) {
			nstr = '.' + nstr;
		}
	} else {
		for (var i=0;i<loadingCtr;i++) {
			nstr += '.';
		}
	}
	obj.innerHTML = nstr;
}

function startwidget() 
{
	if (!window.widget && !debug) {
		return;
	}
	
	checkScreen();
	//display version
	document.getElementById("version").innerHTML = version;
	
	//add trasnalted static labels
	document.getElementById("wMapLoad").innerHTML = localizedText['qtn_loading'];
	document.getElementById("calcellday_sun").innerHTML = localizedText['qtn_sun'];
	document.getElementById("calcellday_mon").innerHTML = localizedText['qtn_mon'];
	document.getElementById("calcellday_tue").innerHTML = localizedText['qtn_tue'];
	document.getElementById("calcellday_wed").innerHTML = localizedText['qtn_wed'];
	document.getElementById("calcellday_thu").innerHTML = localizedText['qtn_thu'];
	document.getElementById("calcellday_fri").innerHTML = localizedText['qtn_fri'];
	document.getElementById("calcellday_sat").innerHTML = localizedText['qtn_sat'];
	document.getElementById("pLabel1").innerHTML = localizedText['qtn_add_location'];
	document.getElementById("pLabel2").innerHTML = localizedText['qtn_saved'];
	document.getElementById("pLabel3").innerHTML = localizedText['qtn_settings'];
	document.getElementById("pText1").innerHTML = localizedText['qtn_search_instructions'];
	document.getElementById("help_about").innerHTML = localizedText['qtn_help'];
	document.getElementById("t_and_c").innerHTML = localizedText['qtn_terms'];
	
	//navigation
	document.getElementById("nLabelForecast").innerHTML = localizedText['qtn_forecast'];
	document.getElementById("nLabelHourly").innerHTML = localizedText['qtn_hourly'];
	document.getElementById("nLabelMaps").innerHTML = localizedText['qtn_maps'];
	document.getElementById("nLabelGraph").innerHTML = localizedText['qtn_graph'];
	document.getElementById("nLabelCalendar").innerHTML = localizedText['qtn_calendar'];
	document.getElementById("nLabelAdd").innerHTML = localizedText['qtn_add_button'];
	document.getElementById("nLabelManage").innerHTML = localizedText['qtn_manage_button'];
	document.getElementById("nLabelSettings").innerHTML = localizedText['qtn_settings_button'];
	
	document.getElementById("zipselect").innerHTML = localizedText['qtn_done'];
	document.getElementById("button_manage_done").innerHTML = localizedText['qtn_done'];
	document.getElementById("button_settings_done").innerHTML = localizedText['qtn_done'];
	document.getElementById("zipsrch").innerHTML = localizedText['qtn_search'];
	document.getElementById("removeloc").innerHTML = localizedText['qtn_remove'];
	document.getElementById("setDefaultLoc").innerHTML = localizedText['qtn_set_default'];
	
	//key
	document.getElementById("wKeyClear0").innerHTML = localizedText['qtn_clear'];
	document.getElementById("wKeyCloudy0").innerHTML = localizedText['qtn_cloudy'];
	document.getElementById("wKeyRain0").innerHTML = localizedText['qtn_rain'];
	document.getElementById("wKeySnow0").innerHTML = localizedText['qtn_snow'];
	document.getElementById("wKeyIce0").innerHTML = localizedText['qtn_ice'];
	document.getElementById("wKeyClear1").innerHTML = localizedText['qtn_clear'];
	document.getElementById("wKeyCloudy1").innerHTML = localizedText['qtn_cloudy'];
	document.getElementById("wKeyRain1").innerHTML = localizedText['qtn_rain'];
	document.getElementById("wKeySnow1").innerHTML = localizedText['qtn_snow'];
	document.getElementById("wKeyIce1").innerHTML = localizedText['qtn_ice'];
	
	if (!debug)
	{
		try {	
			
			sysinfo = document.embeds[0];
			
			zipStr = widget.preferenceForKey(makeKey("zipStr"));
			locStr = widget.preferenceForKey(makeKey("locStr"));
			units = widget.preferenceForKey(makeKey("units"));
			ckeVersion = widget.preferenceForKey(makeKey("version"));
			zipDef = widget.preferenceForKey(makeKey("default"));
			datefmt = widget.preferenceForKey(makeKey("datefmt"));
			zipRecent = widget.preferenceForKey(makeKey("recent"));
			
			var optionsMenu = window.menu;
			var m1 = new MenuItem(localizedText['qtn_add'],2001);
			var m2 = new MenuItem(localizedText['qtn_manage'],2002);
			var m3 = new MenuItem(localizedText['qtn_settings'],2003);
			var m4 = new MenuItem(localizedText['qtn_refresh'],2004);
			var m6 = new MenuItem(localizedText['qtn_cancel_gps'],2008);	
			
			m1.onSelect = menuEventHandler;	
			m6.onSelect = menuEventHandler;	
			m2.onSelect = menuEventHandler;	
			m3.onSelect = menuEventHandler;	
			m4.onSelect = menuEventHandler;	
			
			optionsMenu.append(m6);
			optionsMenu.append(m1);
			optionsMenu.append(m2);
			optionsMenu.append(m3);
			optionsMenu.append(m4);
			
			optionsMenu.getMenuItemById(2002).setDimmed(true);
			optionsMenu.getMenuItemById(2008).setDimmed(true);
			optionsMenu = null;
		} catch (e) {
			//alert('WRT API error: ' + e);	
		}
		
	}
	else
	{
		units = getCookie('units');
		ckeVersion = getCookie('version');
		zipStr = getCookie('zipStr');
		locStr = getCookie('locStr');
		zipDef = getCookie("default");
		datefmt = getCookie("datefmt");
		zipRecent = getCookie("recent");
	}
	
	if (units == "" || units == null)
	{
		units = "metric";
		if (!debug) {
			widget.setPreferenceForKey(units,makeKey("units"));
		} else {
			setCookie('units',units,300, false, false, false);
		}
	}
	
	if (datefmt == "" || datefmt == null)
	{
		datefmt = "dd";
		if (!debug) {
			widget.setPreferenceForKey(datefmt,makeKey("datefmt"));
		} else {
			setCookie('datefmt',datefmt,300, false, false, false);
		}
	}
	
	//format the mv for arabic
	if (LAYOUT_RIGHT2LEFT) {
		document.getElementById("mvCurrentText").style.textAlign = 'right';
	} else {
		document.getElementById("mvCurrentText").style.textAlign = 'left';
	}
	
	
	//set up the location array
	if (zipStr != "" && zipStr != null)
	{
		var zAr = zipStr.split("~");
		var lAr = locStr.split("~");
		for (var i=0;i<zAr.length;i++)
		{
			if (zAr[i] != '' && zAr[i] != null && zAr[i] != 'undefined') {
				zipAr.push(zAr[i]);
				locAr.push(lAr[i]);
			}
		}
		
		zip = zipAr[0];
		
		if (zipDef == 'gps') {
			startCalled = true;
			setLocationList(true);
			document.getElementById("mvLocation").innerHTML = "AccuWeather.com";
			document.getElementById("mvCurrentText").innerHTML = localizedText['qtn_get_position'];
			setTimeout("hidePrefs()",100);
			setTimeout("getLocation()",200);
			return;
		} 
		
		for (var i=0;i<zipAr.length;i++)
		{
			if (zipAr[i] == zipDef) {
				zip = zipAr[i];
				break;
			}
		}
		
		if (zipDef == '' || zipDef == null) {
			if (zipRecent != null && zipRecent != '') {
				if (zipRecent == 'gps') {
					startCalled = true;
					setLocationList(true);
					document.getElementById("mvLocation").innerHTML = "AccuWeather.com";
					document.getElementById("mvCurrentText").innerHTML = localizedText['qtn_get_position'];
					setTimeout("hidePrefs()",100);
					setTimeout("getLocation()",200);
					return;
				} else {
					zip = zipRecent;
				}
			}
		}
		
		setLocationList(false);
		document.getElementById("mvLocation").innerHTML = "AccuWeather.com";
		document.getElementById("mvCurrentText").innerHTML = localizedText['qtn_loading'];
		setTimeout("hidePrefs()",100);
		setTimeout("loadWeather(zip,units)",200);
	}
	else
	{
		setLocationList(true);
		document.getElementById("mvLocation").innerHTML = "AccuWeather.com";
		document.getElementById("mvCurrentText").innerHTML = localizedText['qtn_get_position'];
		setTimeout("hidePrefs()",100);
		setTimeout("getLocation()",200);
	}
	startCalled = true;
}

function menuEventHandler(id)
{
	switch (id)
	{
		case 2001:
			setTimeout("toggleSettings('a')",10);
			setTimeout("showPrefs()",20);
			break;
		case 2002:
			setTimeout("toggleSettings('m')",10);
			setTimeout("showPrefs()",20);
			break;
		case 2003:
			setTimeout("toggleSettings('s')",10);
			setTimeout("showPrefs()",20);
			break;
		case 2004:
			if (gpsZip != 'none') {
				setTimeout("loadWeather(gpsZip,units)",10);
			} else {
				setTimeout("loadWeather(zip,units)",10);
			}
			break;
		case 2008:
			setTimeout("cancelGPS()",10);
			break;
	}
}



function togglewxview(idx)
{
	//turn off old view
	if (!DataComplete) {
		return;	
	}
	
	vibrate();
	switch (wxview)
	{
		case 'hourly':
			document.getElementById('nHourly').getElementsByTagName('img').item(0).src = imgNavHourlyOff.src;
			document.getElementById("wHourly").style.display = 'none';
			clearHourly();
			break;
		case 'forecast':
			document.getElementById('nForecast').getElementsByTagName('img').item(0).src = imgNavForecastOff.src;
			document.getElementById("wForecast").style.display = 'none';
			clearForecast();
			break;
		case 'graph':
			document.getElementById('nGraph').getElementsByTagName('img').item(0).src = imgNavGraphOff.src;
			document.getElementById("wGraph").style.display = 'none';
			clearGraph();
			break;
		case 'calendar':
			document.getElementById('nCalendar').getElementsByTagName('img').item(0).src = imgNavCalendarOff.src;
			document.getElementById("wCalendar").style.display = 'none';
			clearCalendar();
			break;
		case 'map':
			document.getElementById('nMaps').getElementsByTagName('img').item(0).src = imgNavMapsOff.src;
			document.getElementById("wMaps").style.display = 'none';
			break;
	}
	
	//turn on new view
	switch (idx)
	{
		case 'h':
			drawHourly();
			document.getElementById('nHourly').getElementsByTagName('img').item(0).src = imgNavHourlyOn.src;
			document.getElementById("wHourly").style.display = 'block';
			wxview = "hourly";
			break;
		 case "f" : 
			drawForecast();
			document.getElementById('nForecast').getElementsByTagName('img').item(0).src = imgNavForecastOn.src;
			document.getElementById("wForecast").style.display = 'block';
			wxview = "forecast";
			break;
		case 'm':
			document.getElementById('nMaps').getElementsByTagName('img').item(0).src = imgNavMapsOn.src;
			document.getElementById("wMaps").style.display = 'block';
			wxview = "map";	
			break;
		case 'g':
			if (screenMode == 1) {
				drawGraph(159);
			} else if (screenMode == 0) {
				drawGraph(181);
			}
			document.getElementById('nGraph').getElementsByTagName('img').item(0).src = imgNavGraphOn.src;
			document.getElementById("wGraph").style.display = 'block';
			wxview = "graph";
			break;
		case 'c':
			drawCalendar();
			document.getElementById('nCalendar').getElementsByTagName('img').item(0).src = imgNavCalendarOn.src;
			document.getElementById("wCalendar").style.display = 'block';
			wxview = "calendar";
			break;
	}
	if (screenMode == 0) {	
		loadAd();
	}
}

function setRecentZip(isGPS)
{
	if (isGPS) {
		zipRecent = 'gps';
	} else {
		zipRecent = zip;
	}
	
	if (!debug) {
		widget.setPreferenceForKey(zipRecent,makeKey("recent"));
	} else {
		setCookie('recent',zipRecent,300, false, false, false);
	}
}



function showCity()
{
	var box = document.getElementById("citySelect");
	var idx = box.selectedIndex;
	if (box.options[idx] != null && box.options[idx].value != '')
	{
		var selected = box.options[idx].value;
		var stext = box.options[idx].text;
		if (selected == 'add') {
			toggleSettings('a');
			setTimeout("showPrefs()",100);
		} else if (selected == 'gps') {
			setTimeout("getLocation()",100);
		} else if (selected != null && selected != '') {
			zip = selected;
			document.getElementById("locsmenu").selectedIndex = idx;
			document.getElementById("locsmenu_bg").innerHTML = box.options[idx].text.slice(0,25);
			gpsZip = 'none';
			setTimeout("loadWeather(zip,units)",100);
		}
	}
}


function saveCities()
{
	zipStr = "";
	locStr = "";
	var len = zipAr.length;
	if (len > 10) {
		len = 10;
	}
	for (var i=0;i<len;i++)
	{
		if (zipAr[i] != "" && zipAr[i] != null && zipAr[i] != "undefined")	{
			zipStr += zipAr[i] + "~";
			locStr += locAr[i] + "~";
		}
	}
	
	if (!debug) {
		widget.setPreferenceForKey(zipStr,makeKey("zipStr"));
		widget.setPreferenceForKey(locStr,makeKey("locStr"));
	} else {
		setCookie('zipStr',zipStr,300, false, false, false);
		setCookie('locStr',locStr,300, false, false, false);
	}
}


function setLocationList(isGPS)
{
	var box = document.getElementById("locsmenu");	
	var box1 = document.getElementById("citySelect");
	box.options.length = 0;
	box1.options.length = 0;
	box1.setAttribute('onchange', null);
	
	box.options[0] = new Option(localizedText['qtn_current_location'], 'gps');
	box1.options[0] = new Option(localizedText['qtn_current_location'], 'gps');
	document.getElementById("locsmenu_bg").innerHTML = box.options[0].text.slice(0,25);
	box.selectedIndex = 0;
	box1.selectedIndex = 0;
	
	if (zipAr.length > 0)
	{
		for (var i=0;i<zipAr.length;i++)
		{
			if (zipAr[i] != null && zipAr[i] != '')	
			{
				box.options[i+1] = new Option(locAr[i], zipAr[i]);
				box1.options[i+1] = new Option(locAr[i], zipAr[i]);
				if (zip == zipAr[i] && isGPS != true) {
					box.selectedIndex = i+1;
					document.getElementById("locsmenu_bg").innerHTML = box.options[i+1].text.slice(0,25);
					box1.selectedIndex = i+1;
				}
			}
		}
	}
	
	if (isGPS == true) {
		document.getElementById("locsmenu_bg").innerHTML = box.options[0].text.slice(0,25);
		box.selectedIndex = 0;
		box1.selectedIndex = 0;
	}
	
	
	if (zipAr.length > 0) {
		if (setview == 'm') {
			document.getElementById("nManage").getElementsByTagName('img').item(0).src = imgNavManageOn.src;
		} else {
			document.getElementById("nManage").getElementsByTagName('img').item(0).src = imgNavManageOff.src;
		}
		document.getElementById("nLabelManage").style.color = '#FFFFFF';
		document.getElementById("nManage").setAttribute('onmousedown','toggleSettings("m")');
		if (!debug) {
			window.menu.getMenuItemById(2002).setDimmed(false);
		}
	} else {
		document.getElementById("nManage").getElementsByTagName('img').item(0).src = 'images/nav_manage_disabled.png';
		document.getElementById("nLabelManage").style.color = '#9E9E9E';
		document.getElementById("nManage").setAttribute('onmousedown',null);
		if (!debug) {
			window.menu.getMenuItemById(2002).setDimmed(true);
		}
	}
		
	box1.options[box1.options.length] = new Option(localizedText['qtn_add'], 'add');
	box1.setAttribute('onchange', 'showCity()');
}

function setDefaultLocation()
{
	vibrate();
	var box = document.getElementById("locsmenu");
	var box1 = document.getElementById("citySelect");
	var idx = box.selectedIndex;
	box1.setAttribute('onchange', null);
	if (box.options[idx] != null)
	{
		var selected = box.options[idx].value;
		var stext = box.options[idx].text;
		if (selected != null && selected != '' && selected != 'add')
		{
			if (!debug)	{
				widget.setPreferenceForKey(selected,makeKey("default"));
			} else {
				setCookie('default',selected,300, false, false, false);
			}
				
			box.selectedIndex = idx;
			box1.selectedIndex = idx;
			document.getElementById("pText2").innerHTML = stext + ' ' + localizedText['qtn_set_as_default'];
		}
	}
	box1.setAttribute('onchange', 'showCity()');
}

function manageLocationsComplete()
{
	vibrate();
	
	var box = document.getElementById("locsmenu");
	var idx = box.selectedIndex;

	if (box.options[idx] != null)
	{
		var selected = box.options[idx].value;
		var stext = box.options[idx].text;
		if (selected == 'gps')
		{
			setLocationList(true);
			document.getElementById("mvLocation").innerHTML = "AccuWeather.com";
			document.getElementById("mvCurrentText").innerHTML = localizedText['qtn_loading'];
			setTimeout("hidePrefs()",100);
			setTimeout("getLocation()",200);
		}
		else if (selected != null && selected != '' && selected != 'add')
		{		
			zip = selected;
			setLocationList(false);
			hidePrefs();
			loadWeather(zip,units);
		}
	}
	else
	{
		if (gpsZip != 'none') {	
			hidePrefs();
			setLocationList(false);
			loadWeather(gpsZip,units);
		} else if (zip != null && zip != "") {
			hidePrefs();
			setLocationList(false);
			loadWeather(zip,units);
		} else {
			toggleSettings('a');
			document.getElementById("nManage").getElementsByTagName('img').item(0).src = 'images/nav_manage_disabled.png';
			document.getElementById("nLabelManage").style.color = '#9E9E9E';
			document.getElementById("nManage").setAttribute('onmousedown',null);
		}
	}
}


function removeSaved()
{
	vibrate();
	var box = document.getElementById("locsmenu");
	var idx = box.selectedIndex;
	if (box.options[idx] != null)
	{
		var selected = box.options[idx].value;
		var stext = box.options[idx].text;
		if (selected != null && selected != '' && selected != 'add' && selected != 'gps')
		{
			var remove = idx;
			for (var i=0;i<zipAr.length;i++)
			{
				if (zipAr[i] == selected) {
					remove = i;
					break;
				}
			}
			
			zipAr.splice(remove,1);
			locAr.splice(remove,1);
			
			if (selected == zipDef) {
				zipDef = '';
				if (!debug)	{
					widget.setPreferenceForKey(zipDef,makeKey("default"));
				} else {
					setCookie('default',zipDef,300, false, false, false);
				}
			}
			
			if (zipAr.length > 0) {	
				zip = zipAr[0];
				setRecentZip(false);
				setLocationList(false);
			} else {
				zip = '';
				setRecentZip(true);
				setLocationList(true);
				document.getElementById("removeloc").setAttribute('onmousedown',null);
				document.getElementById("removeloc").style.webkitBorderImage = 'url(images/button_settings_disabled.png) 0 15 0 15';
				document.getElementById("removeloc").style.color = '#9e9e9e';
				document.getElementById("setDefaultLoc").setAttribute('onmousedown',null);
				document.getElementById("setDefaultLoc").style.webkitBorderImage = 'url(images/button_settings_disabled.png) 0 15 0 15';
				document.getElementById("setDefaultLoc").style.color = '#9e9e9e';
				//if (gpsZip == 'none') {	
					//manageLocationsComplete();
				//}
			}
			
			saveCities();
			document.getElementById("pText2").innerHTML = stext + ' ' + localizedText['qtn_has_been_removed'];
		}
	}
}

function checkDup(str)
{
	for (var i=0;i<zipAr.length;i++)
	{
		if (str == zipAr[i]) {
			return false;
		}
	}
	return true;
}

function searchAgain()
{
	var box = document.getElementById("zipmenu");
	var idx = box.selectedIndex;
	if (box.options.length > 0)
	{
		if (box.options[idx] != null)
		{
			var selected = box.options[idx].value;
			var stext = box.options[idx].text;
			if (selected == 'back') {
				document.getElementById("zipsrchbox").style.display = 'block';
				document.getElementById("zipmenu").style.display = 'none';
				document.getElementById("zipmenu_bg").style.display = 'none';
				document.getElementById("zipbox").value = '';
				disableDoneButton(true);
			} else {
				document.getElementById("zipmenu_bg").innerHTML = stext.slice(0,25);
			}
		}
	}
}

function changeCityLabel()
{
	var box = document.getElementById("locsmenu");
	var idx = box.selectedIndex;
	document.getElementById("locsmenu_bg").innerHTML = box.options[idx].text.slice(0,25);
	document.getElementById("pText2").innerHTML = '';
	if (idx == 0) {
		document.getElementById("removeloc").setAttribute('onmousedown',null);
		document.getElementById("removeloc").style.webkitBorderImage = 'url(images/button_settings_disabled.png) 0 15 0 15';
		document.getElementById("removeloc").style.color = '#9e9e9e';
	} else {
		document.getElementById("removeloc").setAttribute('onmousedown','removeSaved()');
		document.getElementById("removeloc").style.webkitBorderImage = 'url(images/button_settings.png) 0 15 0 15';
		document.getElementById("removeloc").style.color = '#ffffff';
	}
}

function selectLocation()
{	
	vibrate();
	var box = document.getElementById("zipmenu");
	var idx = box.selectedIndex;
	if (box.options.length > 0)
	{
		if (box.options[idx] != null)
		{
			var selected = box.options[idx].value;
			var stext = box.options[idx].text;
			if (selected != null && selected != '' && stext != localizedText['qtn_searching'] && selected != 'back')
			{
				zip = selected;
				gpsZip = 'none';
				if (checkDup(selected) == true) {	
					zipAr.push(selected);
					locAr.push(stext);
					saveCities();
				}
			}
		}
	}
	
	if (gpsZip != 'none') {
		setLocationList(true);
		hidePrefs();
		loadWeather(gpsZip,units);
	} else if (zip != '' && zip != null) {
		setLocationList(false);
		hidePrefs();
		loadWeather(zip,units);
	} else {
		alert(localizedText['qtn_add_location'])	
	}
}


function goToUrl(url)
{
	if (url != "")
	{
		vibrate();
		if (!debug) {
			window.widget.openURL(url);
		} else {
			window.location.href = url;
		}
	}	
}

function displayLocations()
{
	document.getElementById("zipmenu").disabled = false;
	if (loadingInt != null)	{
		clearInterval(loadingInt);
	}
	
	if (searchComplete)
	{
		var locationSelectBox = document.getElementById("zipmenu");
		var len = CurrentSearch.SearchArray.length;
		var scity;
		var sstate;
		var szip;
		var slabel;
		locationSelectBox.options.length = 0;
		if (len > 0)
		{
			document.getElementById("zipmenu").style.display = 'block';
			document.getElementById("zipmenu_bg").style.display = 'block';
			for (var i=0;i<len;++i)
			{
				scity = CurrentSearch.SearchArray[i].city;
				sstate = CurrentSearch.SearchArray[i].state;
				szip = CurrentSearch.SearchArray[i].zip
				slabel = scity  + ', ' + sstate
				locationSelectBox.options[i] = new Option(slabel , szip);
				if (i==0) {
					document.getElementById("zipmenu_bg").innerHTML = slabel.slice(0,25);
				}
			}
			locationSelectBox.options[len] = new Option(localizedText['qtn_search_again'], 'back');
			disableDoneButton(false);
		}
		else
		{
			document.getElementById("zipsrchbox").style.display = 'block';
			document.getElementById("zipbox").value = localizedText['qtn_no_matches'];
		}
		document.getElementById("pSearching").style.display = 'none';
	}
}

function makeSearchList()
{
	vibrate();
	var term = document.getElementById("zipbox").value;
	if (term != "" && term != null)
	{
		document.getElementById("zipsrchbox").style.display = 'none';
		document.getElementById("pSearching").style.display = 'block';
		showProgress('search',document.getElementById("pSearching"));
		loadLocations(term);
	}
}

function showDataError(e)
{
	if (loadingInt != null) {	
		clearInterval(loadingInt);
	}

	document.getElementById("zipsrchbox").style.display = 'block';
	document.getElementById("zipmenu").style.display = 'none';
	document.getElementById("zipmenu_bg").style.display = 'none';
	document.getElementById("pSearching").style.display = 'none';
	if (e != 'wx') {
		alert(localizedText['qtn_error_location']);
	} else {
		if (document.getElementById("rTemp").innerHTML == '') {
			clearWeather();	
			toggleSettings('a');
			showPrefs();
			document.getElementById("mvLocation").innerHTML = "AccuWeather.com";
			document.getElementById("rIcon_mv").src = "images/wxicons/04.png";
			document.getElementById("mvCurrentText").innerHTML = localizedText['qtn_add_location'];
			checkScreen();
		}
		alert(localizedText['qtn_error_weather']);
	}
}

function clearHourly()
{
	var fobj;
	for (var i=0; i<3; ++i)
	{
		fobj = document.getElementById('wHour'+i).getElementsByTagName('p')
		fobj.item(0).innerHTML = '';
		fobj.item(1).getElementsByTagName('img').item(0).src = imgSpace.src;
		fobj.item(2).innerHTML = '';
		fobj.item(3).innerHTML = '';
		fobj.item(4).innerHTML = '';
	}
	fobj = null;
	document.getElementById("wHicon0").src = imgSpace.src;
	document.getElementById("wHicon1").src = imgSpace.src;
	document.getElementById("wHicon2").src = imgSpace.src;
	document.getElementById("wHicon3").src = imgSpace.src;
	document.getElementById("wHicon4").src = imgSpace.src;
	document.getElementById("wHicon5").src = imgSpace.src;
	document.getElementById("wHicon6").src = imgSpace.src;
	document.getElementById("wHour0").setAttribute('onmousedown',null);
	document.getElementById("wHour2").setAttribute('onmousedown',null);
	document.getElementById("wHicon0").setAttribute('onmousedown',null);
	document.getElementById("wHicon6").setAttribute('onmousedown',null);
}

function clearForecast()
{
	var fobj;
	for (var i=0; i<3; ++i)
	{
		fobj = document.getElementById('wFday'+i).getElementsByTagName('p')
		fobj.item(0).innerHTML = '';
		fobj.item(1).getElementsByTagName('img').item(0).src = imgSpace.src;
		fobj.item(2).innerHTML = '';
		fobj.item(3).innerHTML = '';
		fobj.item(4).innerHTML = '';		
	}
	fobj = null;
	document.getElementById("wFicon0").src = imgSpace.src;
	document.getElementById("wFicon1").src = imgSpace.src;
	document.getElementById("wFicon2").src = imgSpace.src;
	document.getElementById("wFicon3").src = imgSpace.src;
	document.getElementById("wFicon4").src = imgSpace.src;
	document.getElementById("wFday0").setAttribute('onmousedown',null);
	document.getElementById("wFday2").setAttribute('onmousedown',null);
	document.getElementById("wFicon0").setAttribute('onmousedown',null);
	document.getElementById("wFicon4").setAttribute('onmousedown',null);
}

function clearCalendar()
{
	for (var i=1;i<22;i++)
	{
		document.getElementById("calcell" + i).style.background = 'none';
		document.getElementById("cd"+i).style.background = 'none';
		document.getElementById("ct"+i).innerHTML = '';
		document.getElementById("cd"+i).innerHTML = '';
	}
}

function clearGraph()
{
	for (var i=0;i<15;i++)
	{
		document.getElementById("g"+i).innerHTML = '';
		document.getElementById("g"+i).style.background = 'none';
		document.getElementById("gt"+i).innerHTML = '';
		document.getElementById("g"+i).style.border = 'none';
	}
}

function clearRadar()
{
	document.getElementById("wMicon0").src = imgSpace.src;
	document.getElementById("wMicon1").src = imgSpace.src;
	document.getElementById("wMicon2").src = imgSpace.src;
	document.getElementById("wMicon3").src = imgSpace.src;
	document.getElementById("wMicon4").src = imgSpace.src;
	document.getElementById("wMicon5").src = imgSpace.src;
	document.getElementById("wMicon6").src = imgSpace.src;
	document.getElementById("wMapZoomIN").setAttribute('onmousedown',null);
	document.getElementById("wMapZoomOUT").setAttribute('onmousedown',null);
	document.getElementById("wMapImg").src = imgSpace.src;
}

function clearCurrent()
{
	document.getElementById("rSevere").style.display = 'none';
	document.getElementById("rSevere_wide").style.display = 'none';
	document.getElementById("cCurrent").setAttribute('onmousedown',null);
	document.getElementById("cCurrent_wide").setAttribute('onmousedown',null);
	document.getElementById("rTemp").innerHTML = '';
	document.getElementById("rIcon").src = imgSpace.src;
	document.getElementById("rText").innerHTML = '';
	document.getElementById("rRealFeel").innerHTML = '';
	document.getElementById("rTemp_wide").innerHTML = ''; //temps
	document.getElementById("rIcon_wide").src = imgSpace.src;
	document.getElementById("rText_wide").innerHTML = '';
	document.getElementById("rRealFeel_wide").innerHTML = '';
}

function clearWeather()
{
	if (loadingInt != null)	{
		clearInterval(loadingInt);
	}
		
	if (gpsTimeout != null)	{
		clearTimeout(gpsTimeout);
	}
		
	if (document.getElementById("rTemp").innerHTML == '') {
		return;
	}
	
	clearCurrent();
	clearHourly();	
	clearForecast();	
	clearGraph();		
	clearCalendar();	
	clearRadar();
}

function updateWeather()
{
	if (updateInt != null) {
		clearInterval(updateInt);
	}
		
	if (!debug) {
		window.menu.getMenuItemById(2008).setDimmed(true);
	}
	
	if (recentZip == 'gps') {
		getLocationUpdate();
	} else if (recentZip != '' && recentZip != null){
		loadData(recentZip,units);
	}
}

function loadWeather(thezip,theunits)
{
	clearWeather();
	if (updateInt != null) {
		clearInterval(updateInt);
	}
	if (!debug) {
		window.menu.getMenuItemById(2008).setDimmed(true);
		if(enableRSK) {
			window.menu.setRightSoftkeyLabel('', null);
		}
	}
	
	if (gpsZip != 'none' && gpsZip != '') {
		setRecentZip(true);
	} else {
		setRecentZip(false);
	}
	
	document.getElementById("mvCurrentText").innerHTML = localizedText['qtn_loading'];
	showProgress('load',document.getElementById("lLocation"));
	loadData(thezip,theunits);
}

function updateAd()
{
	if (CurrentAdCode.code != null && CurrentAdCode.code != "none")
	{
		var adId = document.getElementById("adCode");
		adId.innerHTML = CurrentAdCode.code;
		if (document.getElementById('adCode').getElementsByTagName('a').item(0) != null)
		{
			var adUrl = adId.getElementsByTagName('a').item(0).getAttribute('href');
			adId.getElementsByTagName('a').item(0).setAttribute('href','#');
			adId.getElementsByTagName('a').item(0).style.color = "#000000";
			adId.getElementsByTagName('a').item(0).style.fontWeight = "bold";
			adId.getElementsByTagName('a').item(0).style.fontSize = "14px";
			adId.setAttribute('onmousedown','goToUrl("'+adUrl+'")');
		}
		if (document.getElementById('adCode').getElementsByTagName('a').item(1) != null)
		{
			adId.getElementsByTagName('a').item(1).setAttribute('href','#');
			adId.getElementsByTagName('a').item(1).style.color = "#000000";
			adId.getElementsByTagName('a').item(1).style.fontWeight = "bold";
			adId.getElementsByTagName('a').item(1).style.fontSize = "14px";
		}
	}
	return;
}

function displayWeather() 
{
	if (DataComplete) 
	{		
		if (loadingInt != null) {	
			clearInterval(loadingInt);
		}
		
		drawLocation();
		drawCurrent();
		
		switch (wxview)
		{
			case 'hourly':
				drawHourly();
				break;
			case 'forecast':
				drawForecast();
				break;
			case 'graph':
				if (screenMode == 1) {
					drawGraph(159);
				} else if (screenMode == 0) {
					drawGraph(181);
				}
				break;
			case 'calendar':
				drawCalendar();
				break;
			
		}
		drawRadar();
		loadAd();
		//checkVersion();
		updateInt = setInterval(updateWeather,updateWait * 1000 * 60);	
	} 
	else 
	{
		showDataError('wx');	
	}
}

function checkVersion()
{
	if (version != CurrentProduct.version)
	{
		if (ckeVersion == null || ckeVersion == "")
		{
			alert(localizedText['qtn_new_version']);
			if (!debug)	 {
				widget.setPreferenceForKey(version,makeKey("version"));
			} else {
				setCookie('version',version,300, false, false, false);	
			}
		}
	}
}

function intlDate(str)
{
	if (datefmt == "mm") {
		return str;
	} else {
		var t_ar = str.split("/");
		return t_ar[1] + "/" + t_ar[0];
	}	
}

function drawLocation()
{
	/*
	if (CurrentWatches.isactive == "1")
	{
		document.getElementById("rSevere").style.display = "block";
		document.getElementById("rSevere_wide").style.display = "block";
		document.getElementById("cCurrent").setAttribute('onmousedown','goToUrl(CurrentWatches.url)');
		document.getElementById("cCurrent_wide").setAttribute('onmousedown','goToUrl(CurrentWatches.url)');
	}
	*/
	
	document.getElementById("lLocation").style.textAlign = 'left';
	document.getElementById("mvLocation").style.textAlign = 'left';
	
	var cityName = CurrentLocation.city;
	var changeFormat = false;
	
	if (cityName == "Current Location") {
		cityName = localizedText['qtn_current_location'];
		if (LAYOUT_RIGHT2LEFT) {
			changeFormat = true;
			document.getElementById("lLocation").style.textAlign = 'right';
		}
	}
	
	if (cityName.length>18)  {
		document.getElementById("lLocation").innerHTML = cityName.substr(0,17) + "...";
		if (LAYOUT_RIGHT2LEFT && changeFormat) {
			document.getElementById("mvLocation").style.textAlign = 'right';
			document.getElementById("mvLocation").innerHTML = CurrentConditions.temperature + ' ,' + cityName.substr(0,16);
		} else {
			document.getElementById("mvLocation").innerHTML = cityName.substr(0,16) + ', ' + CurrentConditions.temperature + '&deg;';
		}
	} else {
		document.getElementById("lLocation").innerHTML = cityName;
		if (LAYOUT_RIGHT2LEFT && changeFormat) {
			document.getElementById("mvLocation").style.textAlign = 'right';
			document.getElementById("mvLocation").innerHTML = CurrentConditions.temperature + ' ,' + cityName;
		} else {
			document.getElementById("mvLocation").innerHTML = cityName + ', ' + CurrentConditions.temperature + '&deg;';
		}
	}
}

function drawCurrent()
{
	//portrait
	document.getElementById("rTemp").innerHTML = CurrentConditions.temperature + '&deg;'; //temps
	document.getElementById("rIcon").src = "images/wxicons/" + CurrentConditions.icon + ".png";
	document.getElementById("rText").innerHTML = CurrentConditions.text;
	document.getElementById("rRealFeel").innerHTML = 'RealFeel<sup>&reg;</sup>: ' + CurrentConditions.realFeel+'&deg;';
	
	//landscape
	document.getElementById("rTemp_wide").innerHTML = CurrentConditions.temperature + '&deg;'; //temps
	document.getElementById("rIcon_wide").src = "images/wxicons/" + CurrentConditions.icon + ".png";
	document.getElementById("rText_wide").innerHTML = CurrentConditions.text;
	document.getElementById("rRealFeel_wide").innerHTML = 'RealFeel<sup>&reg;</sup>: ' + CurrentConditions.realFeel+'&deg;';
	
	//miniview
	document.getElementById("mvCurrentText").style.textAlign = 'left';
	document.getElementById("rIcon_mv").src = "images/wxicons/" + CurrentConditions.icon + ".png";
	document.getElementById("mvCurrentText").innerHTML = CurrentConditions.text;
	
	var j=0;
	if (CurrentLocation.day1 == "2") {
		j=1;
	}
	
	
	document.getElementById("mvTemps").innerHTML = "High: " + CurrentForecasts.forecastArray[j].daytimeHigh  + "&deg;&nbsp;&nbsp;RealFeel: " + CurrentForecasts.forecastArray[j].daytimeRealFeelHigh + "&deg;";

}

function drawRadar()
{
	document.getElementById("wMapImg").src = CurrentImages.radar3 + "&token=" + CurrentImages.key;
	zLevel = 3;
	document.getElementById("wMicon1").src = imgPageIconOff.src;
	document.getElementById("wMicon2").src = imgPageIconOff.src;
	document.getElementById("wMicon3").src = imgPageIconOn.src;
	document.getElementById("wMicon4").src = imgPageIconOff.src;
	document.getElementById("wMicon5").src = imgPageIconOff.src;
	document.getElementById("wMicon0").src = imgPageZoomIn.src;
	document.getElementById("wMicon6").src = imgPageZoomOut.src;
	document.getElementById("wMapZoomIN").setAttribute('onmousedown','zoomRadar("in")');
	document.getElementById("wMapZoomOUT").setAttribute('onmousedown','zoomRadar("out")');
}

function drawForecast()
{
	//check to see if day 1 has already passed
	var j = (CurrentLocation.day1 == "2") ? 1 : 0;
	
	if (LAYOUT_RIGHT2LEFT) {
		 j = j + 2;
	}
	
	var fobj;
	for (var i=0; i<3; ++i)
	{
		fobj = document.getElementById('wFday'+i).getElementsByTagName('p');
		fobj.item(0).innerHTML = CurrentForecasts.forecastArray[j].weekDay + '<br /><span class="fDate">' + intlDate(CurrentForecasts.forecastArray[j].sdate) + '</span>'; 
		if (i==0 && Number(CurrentLocation.hour) > 17) {
			fobj.item(1).getElementsByTagName('img').item(0).src = "images/wxicons/" + CurrentForecasts.forecastArray[j].nighttimeIcon + ".png";
			fobj.item(2).innerHTML = CurrentForecasts.forecastArray[j].nighttimeLow + '&deg;'; 
			fobj.item(3).innerHTML = 'RealFeel';
			fobj.item(4).innerHTML = CurrentForecasts.forecastArray[j].nighttimeRealFeelLow + '&deg;'; 
		} else {
			fobj.item(1).getElementsByTagName('img').item(0).src = "images/wxicons/" + CurrentForecasts.forecastArray[j].daytimeIcon + ".png";
			fobj.item(2).innerHTML = CurrentForecasts.forecastArray[j].daytimeHigh + '&deg;/' + CurrentForecasts.forecastArray[j].nighttimeLow + '&deg;'; 
			fobj.item(3).innerHTML = 'RealFeel';
			fobj.item(4).innerHTML = CurrentForecasts.forecastArray[j].daytimeRealFeelHigh + '&deg;/' + CurrentForecasts.forecastArray[j].nighttimeRealFeelLow + '&deg;'; 
		}
		j = (LAYOUT_RIGHT2LEFT) ? j - 1 : j + 1;
		//j++;
	}
	
	fobj = null;
	fLevel = 1;
	if (LAYOUT_RIGHT2LEFT) {
		document.getElementById("wFicon0").src = imgPageArwLft.src;
		document.getElementById("wFicon1").src = imgPageIconOff.src;
		document.getElementById("wFicon2").src = imgPageIconOff.src;
		document.getElementById("wFicon3").src = imgPageIconOn.src;
		//document.getElementById("wFicon4").src = imgSpace.src;
		document.getElementById("wFday0").setAttribute('onmousedown','showForecast("n")');
		document.getElementById("wFicon0").setAttribute('onmousedown','showForecast("n")');
		document.getElementById("wFday2").setAttribute('onmousedown',null);
		document.getElementById("wFicon4").setAttribute('onmousedown',null);
	} else {
		document.getElementById("wFicon1").src = imgPageIconOn.src;
		document.getElementById("wFicon2").src = imgPageIconOff.src;
		document.getElementById("wFicon3").src = imgPageIconOff.src;
		document.getElementById("wFicon4").src = imgPageArwRgt.src;
		document.getElementById("wFday0").setAttribute('onmousedown',null);
		document.getElementById("wFicon0").setAttribute('onmousedown',null);
		document.getElementById("wFday2").setAttribute('onmousedown','showForecast("n")');
		document.getElementById("wFicon4").setAttribute('onmousedown','showForecast("n")');
	}
}

function drawHourly()
{
	var fobj;
	var j = (LAYOUT_RIGHT2LEFT) ? 2 : 0;
	
	for (var i=0; i<3; ++i)
	{
		fobj = document.getElementById('wHour'+i).getElementsByTagName('p');
		fobj.item(0).innerHTML = CurrentHourly.hourlyArray[j].time + '<br /><span class="fDate">' + intlDate(CurrentHourly.hourlyArray[j].sdate) + '</span>'; 
		fobj.item(1).getElementsByTagName('img').item(0).src = "images/wxicons/" + CurrentHourly.hourlyArray[j].icon + ".png";
		fobj.item(2).innerHTML = CurrentHourly.hourlyArray[j].temp + '&deg;'; 
		fobj.item(3).innerHTML = 'RealFeel';
		fobj.item(4).innerHTML = CurrentHourly.hourlyArray[j].rf + '&deg;';	
		j = (LAYOUT_RIGHT2LEFT) ? j - 1 : j + 1;
	}
	fobj = null;
	hLevel = 1;
	if (LAYOUT_RIGHT2LEFT) {
		document.getElementById("wHicon0").src = imgPageArwLft.src;
		document.getElementById("wHicon1").src = imgPageIconOff.src;
		document.getElementById("wHicon2").src = imgPageIconOff.src;
		document.getElementById("wHicon3").src = imgPageIconOff.src;
		document.getElementById("wHicon4").src = imgPageIconOff.src;
		document.getElementById("wHicon5").src = imgPageIconOn.src;
		document.getElementById("wHour0").setAttribute('onmousedown','showHourly("n")');
		document.getElementById("wHicon0").setAttribute('onmousedown','showHourly("n")');
		document.getElementById("wHour2").setAttribute('onmousedown',null);
		document.getElementById("wHicon6").setAttribute('onmousedown',null);
	} else {
		document.getElementById("wHicon1").src = imgPageIconOn.src;
		document.getElementById("wHicon2").src = imgPageIconOff.src;
		document.getElementById("wHicon3").src = imgPageIconOff.src;
		document.getElementById("wHicon4").src = imgPageIconOff.src;
		document.getElementById("wHicon5").src = imgPageIconOff.src;
		document.getElementById("wHicon6").src = imgPageArwRgt.src;
		document.getElementById("wHour0").setAttribute('onmousedown',null);
		document.getElementById("wHicon0").setAttribute('onmousedown',null);
		document.getElementById("wHour2").setAttribute('onmousedown','showHourly("n")');
		document.getElementById("wHicon6").setAttribute('onmousedown','showHourly("n")');
	}
}


function drawCalendar()
{
	var totalDays = 15;
	var calstart = CurrentForecasts.forecastArray[0].weekDayEng; 
	var j = 0;
	
	//check to see if day 1 has already passed
	if (CurrentLocation.day1 == "2") {
		calstart = CurrentForecasts.forecastArray[1].weekDayEng;
		totalDays = 14;
		j = 1;
	}
	
	switch (calstart) {
		case "Mon" : calstart=2;break;
		case "Tue" : calstart=3;break;
		case "Wed" : calstart=4;break;
		case "Thu" : calstart=5;break;
		case "Fri" : calstart=6;break;
		case "Sat" : calstart=7;break;
		case "Sun" : calstart=1;break;
	}
	
	var len = calstart + totalDays;
	
	for (var i=1;i<22;i++)
	{
		document.getElementById("calcell" + i).style.background = 'none';
		document.getElementById("cd"+i).style.background = 'none';
		document.getElementById("ct"+i).innerHTML = '';
		document.getElementById("cd"+i).innerHTML = '';
	}
	
	for (var i=1; i<22; ++i)
	{
		if (i < len && i >= calstart)
		{
			document.getElementById("calcell" + i).style.backgroundColor = CurrentForecasts.forecastArray[j].daytimeColor;
			document.getElementById("cd"+i).innerHTML = CurrentForecasts.forecastArray[j].wxdate + '&nbsp;';
			document.getElementById("cd"+i).style.background = 'url(images/bg_cal_date.png)';
			document.getElementById("ct"+i).innerHTML = CurrentForecasts.forecastArray[j].daytimeHigh + '&deg;';
			document.getElementById("calcell" + i).style.opacity = '0.7';
			j=j+1;
		}
		else
		{
			document.getElementById("ct"+i).innerHTML = '';
			document.getElementById("cd"+i).innerHTML = '';
		}
	}
}

function toF(num)
{
	var val = num; 
	if (units != 'english') {
		val = (9/5)*num+32
	}
	return parseInt(val);
}

function drawGraph(offset)
{
	var gHigh = -999;
	var gLow = 999;
	for (var i=0; i<15; ++i)
	{
		if (toF(CurrentHourly.hourlyArray[i].temp) > gHigh) {
			gHigh = toF(CurrentHourly.hourlyArray[i].temp);
		}
		if (toF(CurrentHourly.hourlyArray[i].temp) < gLow) {
			gLow = toF(CurrentHourly.hourlyArray[i].temp);
		}
	}
	var gRange = Math.abs(Math.round(gHigh - gLow + 1));
	gHigh = Math.round(gHigh);
	gLow = Math.round(gLow);
	var gTime;
	var ngTime;
	for (var i=0; i<15; ++i)
	{
		var nColor = CurrentHourly.hourlyArray[i].tcolor;
		var gObj = document.getElementById("g"+i);
		gObj.style.backgroundColor = CurrentHourly.hourlyArray[i].color;
		gObj.style.top = (50-(((toF(CurrentHourly.hourlyArray[i].temp)-gLow)/(gRange))*50)) + 'px';
		gObj.style.height = offset - (50-(((toF(CurrentHourly.hourlyArray[i].temp)-gLow)/(gRange))*50)) + 'px';
		gObj.style.borderTop = "1px solid " + nColor;
		gObj.style.borderLeft = "1px solid " + nColor;
		gObj.style.borderRight = "1px solid " + nColor;
		gObj.innerHTML = CurrentHourly.hourlyArray[i].temp;
		gTime = CurrentHourly.hourlyArray[i].time;
		if (gTime == "Mid") {
			gTime = "12 am";
		} else if (gTime == "Noon") {
			gTime = "12 pm";
		}
		ngTime = gTime.split(" ");
		document.getElementById("gt"+i).innerHTML = ngTime[0] + '<br />' + ngTime[1];
	}
	gObj = null;
}


function zoomRadar(dir)
{
	vibrate();
	document.getElementById("wMapImg").src = imgSpace.src;
	document.getElementById("wMicon"+zLevel).src = imgPageIconOff.src;
	if (dir == 'in')
	{
		zLevel--;
		if (zLevel == 0) {
			zLevel = 1;	
		}	
	}
	else
	{
		zLevel++;
		if (zLevel == 6) {
			zLevel = 5;	
		}
	}
	
	switch (zLevel)
	{
		case 1:
			document.getElementById("wMicon0").src = imgSpace.src;
			document.getElementById("wMicon6").src = imgPageZoomOut.src;
			document.getElementById("wMapZoomIN").setAttribute('onmousedown',null);
			document.getElementById("wMapZoomOUT").setAttribute('onmousedown','zoomRadar("out")');
			break;
		case 2:
			document.getElementById("wMicon0").src = imgPageZoomIn.src;
			document.getElementById("wMapZoomIN").setAttribute('onmousedown','zoomRadar("in")');
			document.getElementById("wMapZoomOUT").setAttribute('onmousedown','zoomRadar("out")');
			break;
		case 3:
		case 4:
			document.getElementById("wMicon6").src = imgPageZoomOut.src;
			document.getElementById("wMapZoomIN").setAttribute('onmousedown','zoomRadar("in")');
			document.getElementById("wMapZoomOUT").setAttribute('onmousedown','zoomRadar("out")');
			break;
		case 5:
			document.getElementById("wMicon0").src = imgPageZoomIn.src;
			document.getElementById("wMicon6").src = imgSpace.src;
			document.getElementById("wMapZoomIN").setAttribute('onmousedown','zoomRadar("in")');
			document.getElementById("wMapZoomOUT").setAttribute('onmousedown',null);
			break;
	}
	document.getElementById("wMicon"+zLevel).src = imgPageIconOn.src;
	document.getElementById("wMapImg").src = eval('CurrentImages.radar'+zLevel) + "&token=" + CurrentImages.key;
}

function showHourly(dir)
{
	vibrate();
	for (var i=1;i<6;i++) {	
		document.getElementById("wHicon"+i).src = imgPageIconOff.src;
	}
	if (dir == 'p')
	{
		hLevel--;
		if (hLevel == 0) {
			hLevel = 1;
		}
	}
	else
	{
		hLevel++;
		if (hLevel == 6) {
			hLevel = 5;	
		}
	}
	
	switch (hLevel)
	{
		case 1:
			if (LAYOUT_RIGHT2LEFT) {
				document.getElementById("wHicon5").src = imgPageIconOn.src;
				document.getElementById("wHicon0").src = imgPageArwLft.src;
				document.getElementById("wHicon6").src = imgSpace.src;
				document.getElementById("wHour0").setAttribute('onmousedown','showHourly("n")');
				document.getElementById("wHicon0").setAttribute('onmousedown','showHourly("n")');
				document.getElementById("wHour2").setAttribute('onmousedown',null);
				document.getElementById("wHicon6").setAttribute('onmousedown',null);
			} else {
				document.getElementById("wHicon1").src = imgPageIconOn.src;
				document.getElementById("wHicon0").src = imgSpace.src;
				document.getElementById("wHicon6").src = imgPageArwRgt.src;
				document.getElementById("wHour0").setAttribute('onmousedown',null);
				document.getElementById("wHicon0").setAttribute('onmousedown',null);
				document.getElementById("wHour2").setAttribute('onmousedown','showHourly("n")');
				document.getElementById("wHicon6").setAttribute('onmousedown','showHourly("n")');
			}
			break;
		case 2:
			if (LAYOUT_RIGHT2LEFT) {
				document.getElementById("wHicon4").src = imgPageIconOn.src;
				document.getElementById("wHicon6").setAttribute('onmousedown','showHourly("p")');
				document.getElementById("wHicon6").src = imgPageArwRgt.src;
			} else {
				document.getElementById("wHicon2").src = imgPageIconOn.src;
				document.getElementById("wHicon0").setAttribute('onmousedown','showHourly("p")');
				document.getElementById("wHicon0").src = imgPageArwLft.src;
			}
			break;
		case 3:
			document.getElementById("wHicon3").src = imgPageIconOn.src;
			if (LAYOUT_RIGHT2LEFT) {
				document.getElementById("wHicon6").setAttribute('onmousedown','showHourly("p")');
				document.getElementById("wHour0").setAttribute('onmousedown','showHourly("n")');
				document.getElementById("wHour2").setAttribute('onmousedown','showHourly("p")');
				document.getElementById("wHicon0").setAttribute('onmousedown','showHourly("n")');
			} else {
				document.getElementById("wHicon6").src = imgPageArwRgt.src;
				document.getElementById("wHicon6").setAttribute('onmousedown','showHourly("n")');
				document.getElementById("wHour0").setAttribute('onmousedown','showHourly("p")');
				document.getElementById("wHour2").setAttribute('onmousedown','showHourly("n")');
				document.getElementById("wHicon0").setAttribute('onmousedown','showHourly("p")');
			}
			break;
		case 4:
			if (LAYOUT_RIGHT2LEFT) {
				document.getElementById("wHicon2").src = imgPageIconOn.src;
				document.getElementById("wHicon6").setAttribute('onmousedown','showHourly("p")');
				document.getElementById("wHour0").setAttribute('onmousedown','showHourly("n")');
				document.getElementById("wHour2").setAttribute('onmousedown','showHourly("p")');
				document.getElementById("wHicon0").setAttribute('onmousedown','showHourly("n")');
			} else {
				document.getElementById("wHicon4").src = imgPageIconOn.src;
				document.getElementById("wHicon6").src = imgPageArwRgt.src;
				document.getElementById("wHicon6").setAttribute('onmousedown','showHourly("n")');
				document.getElementById("wHour0").setAttribute('onmousedown','showHourly("p")');
				document.getElementById("wHour2").setAttribute('onmousedown','showHourly("n")');
				document.getElementById("wHicon0").setAttribute('onmousedown','showHourly("p")');
			}
			break;
		case 5:
			if (LAYOUT_RIGHT2LEFT) {
				document.getElementById("wHicon1").src = imgPageIconOn.src;
				document.getElementById("wHicon0").src = imgSpace.src;
				document.getElementById("wHour0").setAttribute('onmousedown',null);
				document.getElementById("wHicon0").setAttribute('onmousedown',null);
				document.getElementById("wHour2").setAttribute('onmousedown','showHourly("p")');
				document.getElementById("wHicon6").setAttribute('onmousedown','showHourly("p")');
			} else {
				document.getElementById("wHicon5").src = imgPageIconOn.src;
				document.getElementById("wHicon6").src = imgSpace.src;
				document.getElementById("wHour0").setAttribute('onmousedown','showHourly("p")');
				document.getElementById("wHicon0").setAttribute('onmousedown','showHourly("p")');
				document.getElementById("wHour2").setAttribute('onmousedown',null);
				document.getElementById("wHicon6").setAttribute('onmousedown',null);
			}
			break;
	}
	
	var fobj;
	var j = (hLevel-1)*3;
	j = (LAYOUT_RIGHT2LEFT) ? j + 2 : j;
	for (var i=0; i<3; ++i)
	{
		fobj = document.getElementById('wHour'+i).getElementsByTagName('p');
		fobj.item(0).innerHTML = CurrentHourly.hourlyArray[j].time + '<br /><span class="fDate">' + intlDate(CurrentHourly.hourlyArray[j].sdate) + '</span>'; 
		fobj.item(1).getElementsByTagName('img').item(0).src = "images/wxicons/" + CurrentHourly.hourlyArray[j].icon + ".png";
		fobj.item(2).innerHTML = CurrentHourly.hourlyArray[j].temp + '&deg;'; 
		fobj.item(3).innerHTML = 'RealFeel';
		fobj.item(4).innerHTML = CurrentHourly.hourlyArray[j].rf + '&deg;';	
		j = (LAYOUT_RIGHT2LEFT) ? j - 1 : j + 1;
	}
	fobj = null;
}

function showForecast(dir)
{
	vibrate();
	document.getElementById("wFicon1").src = imgPageIconOff.src;
	document.getElementById("wFicon2").src = imgPageIconOff.src;
	document.getElementById("wFicon3").src = imgPageIconOff.src;
	
	if (dir == 'p')
	{
		fLevel--;
		if (fLevel == 0) {
			fLevel = 1;	
		}
	}
	else
	{
		fLevel++;
		if (fLevel == 4) {
			fLevel = 3;	
		}
	}
	
	switch (fLevel)
	{
		case 1:
			if (LAYOUT_RIGHT2LEFT) {
				document.getElementById("wFicon3").src = imgPageIconOn.src;
				document.getElementById("wFicon0").src = imgPageArwLft.src;
				document.getElementById("wFicon4").src = imgSpace.src;
				document.getElementById("wFday0").setAttribute('onmousedown','showForecast("n")');
				document.getElementById("wFicon0").setAttribute('onmousedown','showForecast("n")');
				document.getElementById("wFday2").setAttribute('onmousedown',null);
				document.getElementById("wFicon4").setAttribute('onmousedown',null);
			} else {
				document.getElementById("wFicon1").src = imgPageIconOn.src;
				document.getElementById("wFicon0").src = imgSpace.src;
				document.getElementById("wFicon4").src = imgPageArwRgt.src;
				document.getElementById("wFday0").setAttribute('onmousedown',null);
				document.getElementById("wFicon0").setAttribute('onmousedown',null);
				document.getElementById("wFday2").setAttribute('onmousedown','showForecast("n")');
				document.getElementById("wFicon4").setAttribute('onmousedown','showForecast("n")');
			}
			break;
		case 2:
			document.getElementById("wFicon0").src = imgPageArwLft.src;
			document.getElementById("wFicon4").src = imgPageArwRgt.src;
			document.getElementById("wFicon2").src = imgPageIconOn.src;
			if (LAYOUT_RIGHT2LEFT) {
				document.getElementById("wFicon0").setAttribute('onmousedown','showForecast("n")');
				document.getElementById("wFday0").setAttribute('onmousedown','showForecast("n")');
				document.getElementById("wFday2").setAttribute('onmousedown','showForecast("p")');
				document.getElementById("wFicon4").setAttribute('onmousedown','showForecast("p")');
			} else {	
				document.getElementById("wFicon0").setAttribute('onmousedown','showForecast("p")');
				document.getElementById("wFday0").setAttribute('onmousedown','showForecast("p")');
				document.getElementById("wFday2").setAttribute('onmousedown','showForecast("n")');
				document.getElementById("wFicon4").setAttribute('onmousedown','showForecast("n")');
			}
			break;
		case 3:
			if (LAYOUT_RIGHT2LEFT) {
				document.getElementById("wFicon1").src = imgPageIconOn.src;
				document.getElementById("wFicon0").src = imgSpace.src;
				document.getElementById("wFicon4").src = imgPageArwRgt.src;
				document.getElementById("wFday0").setAttribute('onmousedown',null);
				document.getElementById("wFicon0").setAttribute('onmousedown',null);
				document.getElementById("wFday2").setAttribute('onmousedown','showForecast("p")');
				document.getElementById("wFicon4").setAttribute('onmousedown','showForecast("p")');
			} else {	
				document.getElementById("wFicon3").src = imgPageIconOn.src;
				document.getElementById("wFicon4").src = imgSpace.src;
				document.getElementById("wFday0").setAttribute('onmousedown','showForecast("p")');
				document.getElementById("wFicon0").setAttribute('onmousedown','showForecast("p")');
				document.getElementById("wFday2").setAttribute('onmousedown',null);
				document.getElementById("wFicon4").setAttribute('onmousedown',null);
			}
			break;
	}
	
	var fobj;
	var j = (fLevel-1)*3;
	
	j = (LAYOUT_RIGHT2LEFT) ? j + 2 : j;
	
	//check to see if day 1 has already passed
	j = (CurrentLocation.day1 == "2") ? j + 1 : j 
	
	for (var i=0; i<3; ++i)
	{
		fobj = document.getElementById('wFday'+i).getElementsByTagName('p');
		fobj.item(0).innerHTML = CurrentForecasts.forecastArray[j].weekDay + '<br /><span class="fDate">' + intlDate(CurrentForecasts.forecastArray[j].sdate) + '</span>'; 
		if (fLevel == 1 && i==0 && Number(CurrentLocation.hour) > 17) {
			fobj.item(1).getElementsByTagName('img').item(0).src = "images/wxicons/" + CurrentForecasts.forecastArray[j].nighttimeIcon + ".png";
			fobj.item(2).innerHTML = CurrentForecasts.forecastArray[j].nighttimeLow + '&deg;'; 
			fobj.item(3).innerHTML = 'RealFeel';
			fobj.item(4).innerHTML = CurrentForecasts.forecastArray[j].nighttimeRealFeelLow + '&deg;'; 
		} else {
			fobj.item(1).getElementsByTagName('img').item(0).src = "images/wxicons/" + CurrentForecasts.forecastArray[j].daytimeIcon + ".png";
			fobj.item(2).innerHTML = CurrentForecasts.forecastArray[j].daytimeHigh + '&deg;/' + CurrentForecasts.forecastArray[j].nighttimeLow + '&deg;'; 
			fobj.item(3).innerHTML = 'RealFeel';
			fobj.item(4).innerHTML = CurrentForecasts.forecastArray[j].daytimeRealFeelHigh + '&deg;/' + CurrentForecasts.forecastArray[j].nighttimeRealFeelLow + '&deg;'; 
		}
		j = (LAYOUT_RIGHT2LEFT) ? j - 1 : j + 1;
	}
	fobj = null;
}

function changeUnits()
{
	vibrate();
	if (units == "metric")	{
		document.getElementById("unitselect").src = 'images/degree_f.png';
		units = 'english';
	} else {
		document.getElementById("unitselect").src = 'images/degree_c.png';
		units = 'metric';
	}
	
	if (!debug) {
		widget.setPreferenceForKey(units,makeKey("units"));
	} else {
		setCookie('units',units,300, false, false, false);
	}
}


function changeDateFmt()
{
	vibrate();
	if (datefmt == "dd") {
		document.getElementById("dateFmtselect").src = 'images/days_mmdd.png';
		datefmt = 'mm';
	} else {
		document.getElementById("dateFmtselect").src = 'images/days_ddmm.png';
		datefmt = 'dd';
	}
	
	if (!debug) {
		widget.setPreferenceForKey(datefmt,makeKey("datefmt"));
	} else {
		setCookie('datefmt',datefmt,300, false, false, false);
	}
}

function showPrefs()
{
	if (gpsTimeout != null)	{
		clearTimeout(gpsTimeout);
	}
	
	document.getElementById("zipmenu").style.display = 'none';
	document.getElementById("zipmenu_bg").style.display = 'none';
	document.getElementById("zipsrchbox").style.display = 'block';
	document.getElementById("pText2").innerHTML = '';
		
	if (zipAr.length > 0) {
		document.getElementById("nManage").getElementsByTagName('img').item(0).src = imgNavManageOff.src;
		document.getElementById("nManage").setAttribute('onmousedown','toggleSettings("m")');
		document.getElementById("nLabelManage").style.color = '#FFFFFF';
		document.getElementById("removeloc").setAttribute('onmousedown','removeSaved()');
		document.getElementById("removeloc").style.webkitBorderImage = 'url(images/button_settings.png) 0 15 0 15';
		document.getElementById("removeloc").style.color = '#ffffff';
		document.getElementById("setDefaultLoc").setAttribute('onmousedown','setDefaultLocation()');
		document.getElementById("setDefaultLoc").style.webkitBorderImage = 'url(images/button_settings.png) 0 15 0 15';
		document.getElementById("setDefaultLoc").style.color = '#ffffff';
	} else {
		document.getElementById("nManage").getElementsByTagName('img').item(0).src = 'images/nav_manage_disabled.png';
		document.getElementById("nLabelManage").style.color = '#9E9E9E';
		document.getElementById("nManage").setAttribute('onmousedown',null);
		document.getElementById("removeloc").setAttribute('onmousedown',null);
		document.getElementById("removeloc").style.webkitBorderImage = 'url(images/button_settings_disabled.png) 0 15 0 15';
		document.getElementById("removeloc").style.color = '#9e9e9e';
		document.getElementById("setDefaultLoc").setAttribute('onmousedown',null);
		document.getElementById("setDefaultLoc").style.webkitBorderImage = 'url(images/button_settings_disabled.png) 0 15 0 15';
		document.getElementById("setDefaultLoc").style.color = '#9e9e9e';
	}
		
	if (units == "metric")	{
		document.getElementById("unitselect").src = 'images/degree_c.png';
	} else {
		document.getElementById("unitselect").src = 'images/degree_f.png';
	}
	
	if (datefmt == "mm")	{
		document.getElementById("dateFmtselect").src = 'images/days_mmdd.png';
	} else {
		document.getElementById("dateFmtselect").src = 'images/days_ddmm.png';
	}
	
	setTimeout('displayFront(false);',20);
	
	if (debug) {
		return;
	}
	
	window.menu.getMenuItemById(2001).setDimmed(true);
	window.menu.getMenuItemById(2002).setDimmed(true);
	window.menu.getMenuItemById(2003).setDimmed(true);
	window.menu.getMenuItemById(2004).setDimmed(true);
	window.menu.getMenuItemById(2008).setDimmed(true);

	setRSK();
}


function setRSK() {
	
	if (debug) {
		return;	
	}
	
	if (enableRSK) {	
		if (zip != '' && zip != null) {
			window.menu.setRightSoftkeyLabel(localizedText['qtn_back'], hidePrefs);
		} else if (gpsZip != 'none') {
			window.menu.setRightSoftkeyLabel(localizedText['qtn_back'], hidePrefs);
		} else {
			window.menu.setRightSoftkeyLabel('', null);
		}		
	}
}

function hidePrefs()
{
	setTimeout('displayFront(true);',20);
			
	if (gpsZip != 'none') {
		setLocationList(true);	
	} else {
		setLocationList(false);
	}
	
	if (debug) {
		return;
	}
	
	window.menu.getMenuItemById(2001).setDimmed(false);
	if (zipAr.length > 0) {	
		window.menu.getMenuItemById(2002).setDimmed(false);
	}
	window.menu.getMenuItemById(2003).setDimmed(false);
	window.menu.getMenuItemById(2004).setDimmed(false);
	window.menu.getMenuItemById(2008).setDimmed(true);

	if (enableRSK) {	
		window.menu.setRightSoftkeyLabel('', null);
	}
	
	
}

function displayFront(front) {
	if (front) {
		document.getElementById("front").style.display = 'block';
		document.getElementById("back").style.display = 'none';	
	} else {
		document.getElementById("front").style.display = 'none';
		document.getElementById("back").style.display = 'block';	
	}
}

function toggleSettings(type)
{
	vibrate();
	//turn off old one
	switch (setview)
	{
		case 'a' :
			document.getElementById('nAdd').getElementsByTagName('img').item(0).src = imgNavAddOff.src;
			document.getElementById('back_add').style.display = 'none';
			break;
		case 'm' :
			if (document.getElementById('nManage').getElementsByTagName('img').item(0).src == imgNavManageOn.src) {	
				document.getElementById('nManage').getElementsByTagName('img').item(0).src = imgNavManageOff.src;
			}
			document.getElementById('back_manage').style.display = 'none';
			break;
		case 's' :
			document.getElementById('nSettings').getElementsByTagName('img').item(0).src = imgNavSettingsOff.src;
			document.getElementById('back_settings').style.display = 'none';
			break;
	}
	
	//turn on new one
	switch(type)
	{
		case 'a' :
			if (zipAr.length == 0) {
				document.getElementById("nManage").getElementsByTagName('img').item(0).src = 'images/nav_manage_disabled.png';
				document.getElementById("nLabelManage").style.color = '#9E9E9E';
				document.getElementById("nManage").setAttribute('onmousedown',null);
			}
			document.getElementById('nAdd').getElementsByTagName('img').item(0).src = imgNavAddOn.src;
			//reset search stuff
			document.getElementById("zipmenu").options.length = 0;
			document.getElementById("zipbox").value = '';
			disableDoneButton(true);
			document.getElementById("zipbox").focus();
			document.getElementById('back_add').style.display = 'block';
			break;
		case 'm' :
			document.getElementById('nManage').getElementsByTagName('img').item(0).src = imgNavManageOn.src;
			document.getElementById("nLabelManage").style.color = '#FFFFFF';
			document.getElementById("pText2").innerHTML = '';
			document.getElementById('back_manage').style.display = 'block';
			break;
		case 's' :
			if (zipAr.length == 0) {
				document.getElementById("nManage").getElementsByTagName('img').item(0).src = 'images/nav_manage_disabled.png';
				document.getElementById("nLabelManage").style.color = '#9E9E9E';
				document.getElementById("nManage").setAttribute('onmousedown',null);
			}
			document.getElementById('nSettings').getElementsByTagName('img').item(0).src = imgNavSettingsOn.src;
			document.getElementById('back_settings').style.display = 'block';
			break;
	}
	setview = type;
}

function disableDoneButton(disable)
{
	if (disable) {
		document.getElementById("zipselect").setAttribute('onmousedown',null);
		document.getElementById("zipselect").style.webkitBorderImage = 'url(images/button_settings_disabled.png) 0 15 0 15';
		document.getElementById("zipselect").style.color = '#9e9e9e';	
	} else {
		document.getElementById("zipselect").setAttribute('onmousedown','selectLocation()');
		document.getElementById("zipselect").style.webkitBorderImage = 'url(images/button_settings.png) 0 15 0 15';
		document.getElementById("zipselect").style.color = '#ffffff';
	}
}

function clearSearchBox()
{
	if (document.getElementById("zipbox").value == localizedText['qtn_no_matches']) {	
		document.getElementById("zipbox").value = '';	
	}
}


function setCookie(name, value, expires, path, domain, secure) 
{ 
	var exdate=new Date();
	exdate.setDate(exdate.getDate()+expires);
	var curCookie = name + "=" + escape(value) + 
		((expires) ? "; expires=" + exdate.toGMTString() : "") + 
		((path) ? "; path=" + path : "") + 
		((domain) ? "; domain=" + domain : "") + 
		((secure) ? "; secure" : ""); 
	 	document.cookie = curCookie; 
}

function getCookie(c_name)
{
	if (document.cookie.length>0)
	{
		c_start=document.cookie.indexOf(c_name + "=");
		if (c_start!=-1)
		{ 
			c_start=c_start + c_name.length+1;
			c_end=document.cookie.indexOf(";",c_start);
			if (c_end==-1) c_end=document.cookie.length;
			return unescape(document.cookie.substring(c_start,c_end));
		} 
	}
	return;
}

function changeLayout(mode)
{
	if (mode == 2) {
		changeLayout2Mini();
	} else if (mode == 0)	{
		changeLayout2Portrait();
	} else {
		changeLayout2Landscape();
	}
}


function changeLayout2Mini() {
	
	var wrapper = document.getElementById('wrapper');
	
	document.getElementById('miniview').style.display = 'block';
	wrapper.style.display = 'none';
	wrapper.style.background = 'none';
	document.getElementById('cWeather').style.background = 'none';
	document.getElementById('cAbout').style.background = 'none';
	document.getElementById('logo_main').src = '#';
	document.getElementById('logo_leaf').src = '#';
	document.getElementById('cNavigation').style.background = 'none';
	document.getElementById('cCurrent').style.background = 'none';
	document.getElementById('cCurrent_wide').style.background = 'none';
	document.getElementById('cLocation').style.background = 'none';
	document.getElementById('cPrefs').style.background = 'none';
	
	wrapper = null;
}

function changeLayout2Landscape() {
	
	var wrapper = document.getElementById('wrapper');
	var cWeather = document.getElementById('cWeather');
	var cAbout = document.getElementById('cAbout');
	var mini = document.getElementById('miniview');
	
	wrapper.style.display = 'block';
	mini.style.display = 'none';
	wrapper.style.height = '360px';
	wrapper.style.width = '502px';
	wrapper.style.background = 'url(images/bg_landscape.jpg)';
	document.getElementById('logo_main').src = '#';
	document.getElementById('logo_leaf').src = 'images/logo_leaf.png';
	document.getElementById('headPortrait').style.display = 'none';
	document.getElementById('landscapeHead').style.display = 'block';
	document.getElementById('landscapeWrapper').style.position = 'absolute';
	document.getElementById('landscapeWrapper').style.top = '0px';
	document.getElementById('landscapeWrapper').style.right = '0px';
	document.getElementById('cCurrent').style.display = 'none';
	document.getElementById('cAdSpot').style.display = 'none';
	
	document.getElementById('cNavigation').style.background = 'url(images/bg_fade_nav.png) no-repeat';
	document.getElementById('cCurrent_wide').style.background = 'url(images/bg_fade_current_wide.png) no-repeat';
	document.getElementById('cCurrent').style.background = 'none';
	document.getElementById('cLocation').style.background = 'url(images/bg_location.png) no-repeat';
	
	document.getElementById('citySelect').style.height = '60px';
	document.getElementById('gpsButton').style.height = '60px';
	
	//adjust the weather screen
	cWeather.style.height = '216px';
	cWeather.style.background = 'url(images/bg_fade_content_wide.png)';
	changecss('p.wFdayIconCon','height','85px');
	changecss('p.wFdayTemp','height','25px');
	document.getElementById('wMapImgCon').style.height = '187px';
	document.getElementById('wMapImg').style.height = '180px';
	document.getElementById('wMapImg').style.marginTop = '4px';
	document.getElementById('calendar').style.paddingTop = '7px';
	changecss('.wMapZoom','height','180px');
	changecss('.wMapZoom','top','4px');
	changecss('.calcell','height','43px');
	changecss('.wPrecipKey','top','168px');
	changecss('.wFiconClassAr','top','-100px');
	
	if (DataComplete){
		drawGraph(159);
	}
	document.getElementById('graphtime').style.top = '148px';
	document.getElementById('graph').style.paddingTop = '0px';
	
	//settings
	cAbout.style.position = 'absolute';
	cAbout.style.top = '0px';
	cAbout.style.right = '0px';
	cAbout.style.width = '145px';
	cAbout.style.height = '360px';
	cAbout.style.background = 'url(images/bg_fade_about_wide.png) no-repeat';
	document.getElementById('cAboutContainer').style.width = '120px';
	document.getElementById('p_copy').style.width = 'inherit';
	document.getElementById('cPrefs').style.background = 'url(images/bg_fade_prefs.png) no-repeat';
	
	wrapper = null;
	cWeather = null;
	cAbout = null;
	mini = null;
}

function changeLayout2Portrait() {
	
	var wrapper = document.getElementById('wrapper');
	var cWeather = document.getElementById('cWeather');
	var cAbout = document.getElementById('cAbout');
	var mini = document.getElementById('miniview');
	
	wrapper.style.display = 'block';
	mini.style.display = 'none';
	wrapper.style.height = '577px';
	wrapper.style.width = '360px';
	wrapper.style.background = 'url(images/bg_portrait.jpg)';
	document.getElementById('logo_main').src = 'images/logo_accu.png';
	document.getElementById('logo_leaf').src = '#';
	document.getElementById('headPortrait').style.display = 'block';
	document.getElementById('landscapeHead').style.display = 'none';
	document.getElementById('landscapeWrapper').style.position = 'inherit';
	document.getElementById('cCurrent').style.display = 'block';
	document.getElementById('cAdSpot').style.display = 'block';
	
	document.getElementById('cNavigation').style.background = 'url(images/bg_fade_nav.png) no-repeat';
	document.getElementById('cCurrent').style.background = 'url(images/bg_fade_current.png) no-repeat';
	document.getElementById('cCurrent_wide').style.background = 'none';
	document.getElementById('cLocation').style.background = 'url(images/bg_location.png) no-repeat';
	
	document.getElementById('citySelect').style.height = '90px';
	document.getElementById('gpsButton').style.height = '90px';
	
	//adjust the weather screen
	cWeather.style.height = '261px';
	cWeather.style.background = 'url(images/bg_fade_content.png)';
	changecss('p.wFdayIconCon','height','115px');
	changecss('p.wFdayTemp','height','35px');
	document.getElementById('wMapImgCon').style.height = '227px';
	document.getElementById('wMapImg').style.height = '180px';
	document.getElementById('wMapImg').style.marginTop = '25px';
	document.getElementById('calendar').style.paddingTop = '15px';
	changecss('.wMapZoom','height','215px');
	changecss('.wMapZoom','top','9px');
	changecss('.calcell','height','48px');
	changecss('.wPrecipKey','top','200px');
	changecss('.wFiconClassAr','top','-120px');

	if (DataComplete) {	
		drawGraph(181);
	}
	document.getElementById('graphtime').style.top = '180px';
	document.getElementById('graph').style.paddingTop = '10px';
	
	//about 
	cAbout.style.position = 'inherit';
	cAbout.style.width = '360px';
	cAbout.style.height = '192px';
	cAbout.style.background = 'url(images/bg_fade_about.png) no-repeat';
	document.getElementById('cAboutContainer').style.width = '323px';
	document.getElementById('p_copy').style.width = 'inherit';
	document.getElementById('cPrefs').style.background = 'url(images/bg_fade_prefs.png) no-repeat';
	
	wrapper = null;
	cWeather = null;
	cAbout = null;
	mini = null;
}

function checkScreen()
{
	var theScreen;
	if (window.innerHeight < 150)  {
		theScreen = 2; //miniview
	} else if (window.innerWidth > window.innerHeight)  {
		theScreen = 1;	// landscape
	} else {
		theScreen = 0; // portrait
	}
	
	if (theScreen != screenMode) {
		if (screenMode == 2) { // if it was mini, need to show full data
			if(DataComplete) {		
				 displayWeather();			
			}
		}
		
		if (theScreen == 2) { // if it is mini, need to clear full data
			clearWeather();
		}
		screenMode = theScreen;
		changeLayout(screenMode);
	}
}

function makeKey(key)
{
	return (key);
}

function changecss(theClass,element,value) 
{
	var cssRules;
	if (document.all)  {
		cssRules = 'rules';
	} else if (document.getElementById)  {
		cssRules = 'cssRules';
	}
	
	var added = false;
	for (var S = 0; S < document.styleSheets.length; S++)
	{
		for (var R = 0; R < document.styleSheets[S][cssRules].length; R++) 
		{
			if (document.styleSheets[S][cssRules][R].selectorText == theClass) 
			{
				if (document.styleSheets[S][cssRules][R].style[element]) {
					document.styleSheets[S][cssRules][R].style[element] = value;
					added=true;
					break;
				}
			}
		}
	
		if(!added)
		{
			if(document.styleSheets[S].insertRule) {
				document.styleSheets[S].insertRule(theClass+' { '+element+': '+value+'; }',document.styleSheets[S][cssRules].length);
			}  else if (document.styleSheets[S].addRule)  {
				document.styleSheets[S].addRule(theClass,element+': '+value+';');
			}
		}
	}
}

function vibrate()
{
	if (!debug) {
		try  {
			if (sysinfo.vibrasettings == 1) {
				sysinfo.startvibra(25, 40);
			}	
		} catch(e){}
	} else {
		//alert('vibrate');	
	}
}

function vibrateSelectMenu(obj)
{
	if (obj.blur) {
		obj.blur();
	}
	vibrate();
}

function showWidget()
{
	if (!startCalled) {
		return;
	}

	checkScreen();
	
	if (zip != null && zip != '' && gpsZip != 'none') {
		hidePrefs();	
	}
	
	if (!DataComplete) {
		return;
	}
	
	zipRecent = widget.preferenceForKey(makeKey("recent"));
	units = widget.preferenceForKey(makeKey("units"));
	if (units == "" || units == null) {
		units = "metric";
	}
	
	if (zipRecent == 'gps') {
		getLocationUpdate();	
	} else if (zipRecent != "" && zipRecent != null) {
		zip = zipRecent;
		updateWeather();
	} else {
		updateWeather();
	}
}

function hideWidget()
{
	if (updateInt != null) {
		clearInterval(updateInt);
	}
}



function loadWidget()
{
	setTimeout("startwidget()",100);
}


if (!debug)
{
	window.widget.onshow = function() 
	{
		showWidget();
	}
	
	window.widget.onhide = function()
	{
		hideWidget();
	}	
}




