var WeatherUnits;
var CurrentLocation;
var CurrentConditions;
var CurrentImages;
var CurrentForecasts;
var CurrentWatches;
var CurrentHourly;
var CurrentLinks;
var CurrentSearch;
var CurrentAdCode;
var CurrentProduct;
var ErrorString="";
var DataComplete=false;
var searchComplete = false;
var timeout;


function swapIconCode(code)
{
	var newCode = code;
	switch (code)
	{
		case '02':
		case '03':
			newCode = '04';
			break;
		case '08':
			newCode = '07';
			break;
		case '13':
			newCode = '14';
			break;
		case '16':
			newCode = '17';
			break;
		case '20':
			newCode = '21';
			break;
		case '34':
		case '35':
			newCode = '36';
			break;
		case '40':
			newCode = '39';
			break;
		case '42':
			newCode = '41';
			break;
	}
	return newCode;
}


function AdCode(xmlNode)
{
	this.code = xmlNode.firstChild.data;
}

function Product(xmlNode)
{
	this.version = xmlNode.getAttribute('wrt2');
}
	
function Images(xmlNode) 
{
	if (xmlNode.getElementsByTagName('key').item(0).firstChild != null)	 {
		this.key=xmlNode.getElementsByTagName('key').item(0).firstChild.data;
	}
	this.radar1=xmlNode.getElementsByTagName('radar1').item(0).firstChild.data
	this.radar2=xmlNode.getElementsByTagName('radar2').item(0).firstChild.data;
	this.radar3=xmlNode.getElementsByTagName('radar3').item(0).firstChild.data;
	this.radar4=xmlNode.getElementsByTagName('radar4').item(0).firstChild.data;
	this.radar5=xmlNode.getElementsByTagName('radar5').item(0).firstChild.data;
}

function Units(xmlNode) 
{
	this.tempUnit=xmlNode.getAttribute('temp');
	this.speedUnit=xmlNode.getAttribute('speed');
	this.distUnit=xmlNode.getAttribute('dist');
	this.presUnit=xmlNode.getAttribute('pres');
	this.precUnit=xmlNode.getAttribute('prec');
}

function Watches(xmlNode) 
{
	this.zone=xmlNode.getAttribute('zone');
	this.county=xmlNode.getAttribute('county');
	this.isactive=xmlNode.getAttribute('isactive');
	this.alerttype = xmlNode.getAttribute('type');
	if (xmlNode.getElementsByTagName('url').item(0).firstChild!=null) {
		this.url=xmlNode.getElementsByTagName('url').item(0).firstChild.data;
	} else {
		this.url='';
	}
}

function Location(xmlNode) 
{
	this.city=xmlNode.getAttribute('city');
	this.state=xmlNode.getAttribute('state');
	this.wxdate=xmlNode.getAttribute('wxdate');
	this.day=translate(xmlNode.getAttribute('day'));
	this.month=xmlNode.getAttribute('month');
	this.year=xmlNode.getAttribute('year');
	this.intl=xmlNode.getAttribute('intl');
	this.time = xmlNode.getAttribute('time');
	this.hour = xmlNode.getAttribute('hour');
	this.day1 = xmlNode.getAttribute('day1');
}

function Conditions(xmlNode) 
{
	this.url=xmlNode.getElementsByTagName('url').item(0).firstChild.data;
	tempNode=xmlNode.getElementsByTagName('wxc').item(0);
	this.temperature=tempNode.getAttribute('temp');
	this.realFeel=tempNode.getAttribute('rf');
	this.color=tempNode.getAttribute('color');
	this.tcolor=tempNode.getAttribute('tcolor');
	this.text=tempNode.getAttribute('text');
	this.icon=swapIconCode(tempNode.getAttribute('icon'));
	this.radarUrl=xmlNode.getElementsByTagName('radurl').item(0).firstChild.data;
	this.hourlyURL=xmlNode.getElementsByTagName('hourlyurl').item(0).firstChild.data;
}


function Hourly(xmlNode) 
{
	tempNodes=xmlNode.getElementsByTagName('hour');
	tempArray=new Array(tempNodes.length);
	for (count=0;count<tempNodes.length;count++) {
		tempArray[count]=new HourlyHour(tempNodes[count]);
	}
	this.hourlyArray=tempArray;
}

function HourlyHour(xmlNode)
{
	this.date=xmlNode.getAttribute('date');
	var dAr = this.date.split("/");
	this.sdate = dAr[0] + '/' + dAr[1]; 
	this.time=xmlNode.getAttribute('time');
	//this.text=xmlNode.getAttribute('text');
	this.rf=xmlNode.getAttribute('rf');
	//this.wd=xmlNode.getAttribute('wd');
	//this.ws=xmlNode.getAttribute('ws');
	this.temp=xmlNode.getAttribute('temp');
	this.icon=swapIconCode(xmlNode.getAttribute('icon'));
	this.color=xmlNode.getAttribute('color');
	this.tcolor=xmlNode.getAttribute('tcolor');
}

function Search(xmlNode)
{
	tempNodes=xmlNode.getElementsByTagName('location');
	tempArray=new Array(tempNodes.length);
	for (count=0;count<tempNodes.length;count++) {
		tempArray[count]=new SearchResult(tempNodes[count]);
	}
	this.SearchArray=tempArray;
}

function SearchResult(xmlNode)
{
	this.city = xmlNode.getAttribute('city');
	this.state = xmlNode.getAttribute('state');
	this.zip = xmlNode.getAttribute('location');
}


function Forecasts(xmlNode) 
{
	this.url=xmlNode.getElementsByTagName('url').item(0).firstChild.data;
	//this.url15=xmlNode.getElementsByTagName('url15').item(0).firstChild.data;
	tempNodes=xmlNode.getElementsByTagName('day');
	tempArray=new Array(tempNodes.length);
	for (count=0;count<tempNodes.length;count++) {
		tempArray[count]=new ForecastDay(tempNodes[count]);
	}
	this.forecastArray=tempArray;
}

function ForecastDay(xmlNode) 
{
	this.dayNumber=xmlNode.getAttribute('number');
	this.wxdate=xmlNode.getAttribute('wxdate');
	this.date=xmlNode.getAttribute('date');
	var dAr = this.date.split("/");
	this.sdate = dAr[0] + '/'+ dAr[1];
	this.month=xmlNode.getAttribute('month');
	
	var swday = xmlNode.getAttribute('wday');
	switch (swday)
	{
		case 'Sun': this.weekDay = translate('Sunday'); break;
		case 'Mon': this.weekDay = translate('Monday'); break;
		case 'Tue': this.weekDay = translate('Tuesday'); break;
		case 'Wed': this.weekDay = translate('Wednesday'); break;
		case 'Thu': this.weekDay = translate('Thursday'); break;
		case 'Fri': this.weekDay = translate('Friday'); break;
		case 'Sat': this.weekDay = translate('Saturday'); break;
	}
	this.weekDayEng = swday;
	//Daytime forecast data
	var mynode = xmlNode.getElementsByTagName('daytime').item(0);	
	this.daytimeIcon=swapIconCode(mynode.getElementsByTagName('wxf').item(0).getAttribute('icon'));
	this.daytimeHigh=mynode.getElementsByTagName('wxf').item(0).getAttribute('htmp');
	this.daytimeRealFeelHigh=mynode.getElementsByTagName('wxf').item(0).getAttribute('rfh');
	this.daytimeColor=mynode.getElementsByTagName('wxf').item(0).getAttribute('color');
	this.daytimeGTemp=mynode.getElementsByTagName('wxf').item(0).getAttribute('gtmp');
	this.daytimetColor=mynode.getElementsByTagName('wxf').item(0).getAttribute('color');
	this.daytimeWindSpd=mynode.getElementsByTagName('wxf').item(0).getAttribute('ws');
	this.daytimeWindDir=mynode.getElementsByTagName('wxf').item(0).getAttribute('wd');
	this.daytimeTstorm=mynode.getElementsByTagName('wxf').item(0).getAttribute('tst');
	//this.daytimeText=mynode.getElementsByTagName('text').item(0).firstChild.data;
	
	//Nighttime forecast data
	var mynode = xmlNode.getElementsByTagName('nighttime').item(0);
	this.nighttimeIcon=swapIconCode(mynode.getElementsByTagName('wxf').item(0).getAttribute('icon'));
	this.nighttimeLow=mynode.getElementsByTagName('wxf').item(0).getAttribute('ltmp');
	this.nighttimeRealFeelLow=mynode.getElementsByTagName('wxf').item(0).getAttribute('rfl');
	this.nighttimeColor=mynode.getElementsByTagName('wxf').item(0).getAttribute('color');
	//this.nighttimeGTemp=mynode.getElementsByTagName('wxf').item(0).getAttribute('gtmp');
	//this.nighttimeText=mynode.getElementsByTagName('text').item(0).firstChild.data;
}



function loadData(code,theunits) 
{
	metric=1;
	if (theunits=="english") {
		metric=0;
	}
		
	DataComplete = false;
	var req = createXMLHttpRequest();
	if (req) 
	{
		var Myurl = adcUrl + 'weather_data_v3.asp?app=wrt2&partner=wrt2&location=' + code + '&metric=' + metric + '&x=' + Math.random();
		//var Myurl = url + 'weather_data_v3.xml';
		if (code != null && code != "")	{
			loadXMLDoc(req, Myurl, 'wx');
		}
	}
}

function loadAd() 
{
	var req = createXMLHttpRequest();
	if (req) {
		var Myurl = adcUrl + 'getAd.asp?app=wrt2&partner=wrt2&location=' + zip + '&wxicon=' + CurrentConditions.icon + '&x=' + Math.random();	
		loadXMLDoc(req, Myurl, 'ad');
	}
}

function loadXMLDoc(req, url, type) 
{
	req.onreadystatechange = function() {
		processStateChange(req, type);
	}
	req.open("GET", url, true);
	req.setRequestHeader("Content-type", "text/xml");
	req.send(null);
}


function createXMLHttpRequest() 
{
	var req = null;
	try 
	{
		req = new XMLHttpRequest();
		if (typeof req.overrideMimeType != "undefined") {
			req.overrideMimeType("text/xml");
		}
	} catch (ex) {
		req = null;
	}
	return req;
}

function processStateChange(req, type) 
{
	if (req.readyState == 4) 
	{
		if (req.status == 200 || req.status == 0) 
		{
			if (type == 'loc') {
				parseLocations(req.responseXML.documentElement);
			} else if (type == 'wx') {
				parseData(req.responseXML.documentElement);
			} else if (type == 'ad') {
				parseAd(req.responseXML.documentElement);
			}
		}
		else 
		{
			if (type == 'loc')	{
				showDataError();
			} else if (type == 'wx') {
				showDataError('wx');
			}
		}
	} 	
}


function parseData(xmlData) 
{
	try {
		CurrentLocation=new Location(xmlData.getElementsByTagName("local").item(0));
		WeatherUnits=new Units(xmlData.getElementsByTagName("units").item(0));
		CurrentConditions=new Conditions(xmlData.getElementsByTagName("currentconditions").item(0));
		CurrentImages=new Images(xmlData.getElementsByTagName("images").item(0));
		CurrentForecasts=new Forecasts(xmlData.getElementsByTagName("forecast").item(0));
		CurrentWatches=new Watches(xmlData.getElementsByTagName("watchwarnareas").item(0));
		CurrentHourly=new Hourly(xmlData.getElementsByTagName("Hourly").item(0));
		CurrentAdCode=new AdCode(xmlData.getElementsByTagName("adCode").item(0));
		CurrentProduct = new Product(xmlData.getElementsByTagName("product").item(0));
		DataComplete=true;
		setTimeout('displayWeather()',100);
	} catch (e) {
		//alert(e);
		showDataError('wx');
	}
}

function parseAd(xmlData) 
{
	try {
		CurrentAdCode=new AdCode(xmlData.getElementsByTagName("adCode").item(0));
		updateAd();
	} catch (e) {
		//alert(e);
	}
}

function loadLocations(lookupzip)
{
	var req = createXMLHttpRequest();
	if (req) 
	{
		var Myurl = adcUrl + 'locate_city.asp?location=' + lookupzip;
		loadXMLDoc(req, Myurl, 'loc');
	}
}

function parseLocations(xmlData)
{
	try {
		CurrentSearch = new Search(xmlData.getElementsByTagName("citylist").item(0));
		searchComplete = true;
		displayLocations();
	} catch (e) {
		
	}
}

